using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace WindowsUI
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.button2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(136, 88);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(168, 40);
			this.button1.TabIndex = 0;
			this.button1.Text = "Call Web Service";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(424, 72);
			this.label1.TabIndex = 1;
			this.label1.Text = "Debug Solution to demostrate problem.";
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(136, 136);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(168, 40);
			this.button2.TabIndex = 2;
			this.button2.Text = "Call Web Service In seperate thread.";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(440, 182);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.KeyPreview = true;
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.label1.Text = 
				"To demostrate problem:" + Environment.NewLine +
				"1) Quickly click on the 'Call Web Service' button twice." + Environment.NewLine +
				"2) If no error dialog appear, try placing some break point in the code." + Environment.NewLine +
				"3) The problem is quite flaky... and sometime may not appear...";
		}


		public delegate string HelloWorldDelegate();

		//
		// Number of CallWebService is being executed
		//
		private int count = 0;

		/// <summary>
		/// Call HelloWorld Web Service. 
		/// </summary>
		/// <param name="callInSeperateThread">
		/// If true, call web service in seperate thread and block current thread.
		/// If false, call web service in current thread and block current thread.
		/// </param>
		public void CallWebService( bool callInSeperateThread)
		{
			try
			{
				// Increment the process count.
				count++;

				if( count > 1)
				{
					//
					// We have more then 1 CallWebService running, can cause concurrency error.
					//
					MessageBox.Show( 
						String.Format("Number of button click currently processing: {0}", count),
						"Error...", 
						MessageBoxButtons.OK, 
						MessageBoxIcon.Error);
				}

				HelloWorldWebService.HelloWorldService hwSvc = 
					new WindowsUI.HelloWorldWebService.HelloWorldService();

				string msg;

				if( callInSeperateThread)
				{
					// 
					HelloWorldDelegate dlg = new HelloWorldDelegate( hwSvc.HelloWorld);
					IAsyncResult result = dlg.BeginInvoke( null, null);
					msg = dlg.EndInvoke( result); // Block the current thread until finish
				}
				else
				{
					//
					// If running this with DEBUGGER, it will process the Message Queue
					// and fire the next window event before this event is finished.
					//
					msg = hwSvc.HelloWorld();
				}
				MessageBox.Show( msg, "Web Service Result");
			}
			finally
			{
				// Decrement the process count as we leave function
				count--;
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//
			// Call web service normally on the UI thread
			//
			CallWebService( false);
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			//
			// Call web service in a seperate thread, and block UI thread
			//
			CallWebService( true);
		}
	}
}
